/*## (c) SECURITY EXPLORATIONS    2016 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.io.*;
import java.net.*;
import com.sun.net.httpserver.*;

public class HTTPServer {
 public static final String HTTP_ROOT     = "Issue69";
 public static final String SPOOFED_CLASS = "A";

 public static final String BLOCKED_FILE  = HTTP_ROOT+"/"+SPOOFED_CLASS+".class";

 public static final String valid_files[]={
  "index.html",
  "BlackBox.class",
  "Vuln69.class",
  "A.class",
  "/data/Helper.class",
  "/data/Exploit.class",
  "/data/A.class",
  "/data/MyPermissions.class",
  "/data/MyProtectionDomain.class",
  "/data/MyAccessControlContext.class"
 };

 static boolean should_block_A_cl1_class = true;
 
 static class FileHandler implements HttpHandler {   
    public void not_found(HttpExchange t) throws IOException {
      String response="404 (Not Found)\n";

      t.sendResponseHeaders(404,response.length());
      OutputStream os=t.getResponseBody();
      os.write(response.getBytes());
      os.close();
    }

    public void send_file(HttpExchange t,String name) throws IOException {
      File file=new File(name);
      byte[] buf=new byte[(int)file.length()];

      FileInputStream fis=new FileInputStream(file);
      fis.read(buf,0,buf.length);
      fis.close();

      t.sendResponseHeaders(200,buf.length);
      OutputStream os=t.getResponseBody();
      os.write(buf,0,buf.length);
      os.close();
    }

    public boolean valid_file(String name) {
     if (!name.startsWith(HTTP_ROOT+"/")) return false;    
     name=name.substring(HTTP_ROOT.length()+1);

     for(int i=0;i<valid_files.length;i++) {
      if (valid_files[i].equals(name)) return true;
     }

     return false;
    }

    public void handle(HttpExchange t) throws IOException {
      URI uri=t.getRequestURI();
      String path=uri.getPath();

      System.out.println("requesting file: "+path);

      String name=path.substring(1);

      if (name.endsWith(BLOCKED_FILE)) {
       if (should_block_A_cl1_class) {
        should_block_A_cl1_class=false;
        System.out.println("- enforcing 404 (Not Found)");
        not_found(t);
        return;
       } else {
        should_block_A_cl1_class=true;
       }
      }
  
      if (valid_file(name)) send_file(t,name);
       else not_found(t);
   }
 }

 public static void main(String[] args) {
  try {
   System.out.println("Simple HTTP server serving Issue 69 files only");

   if (args.length!=1) {
    System.out.println("usage: HTTPServer portnum");
    System.exit(1);
   }

   int port=-1;

   try {
    port=Integer.parseInt(args[0].trim());
   } catch(Throwable t) {}

   if (port==-1) {
    System.out.println("invalid port number: "+port);
    System.exit(1);
   }

   System.out.println("listening on: "+port);

   HttpServer server=HttpServer.create(new InetSocketAddress(port), 0);
   server.createContext("/"+HTTP_ROOT,new FileHandler());
   server.setExecutor(null);
   server.start();

   Thread.sleep(1000000000);
  } catch (Exception e) {
   e.printStackTrace();
  }
 }
}
